## hydrogen 0.9.7

=== CMakeLists.txt ===
#
# CMAKE SETUP
#

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
# http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
IF(COMMAND CMAKE_POLICY)
#	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)   # add_library
	CMAKE_POLICY(SET CMP0006 NEW)   # bundle destination property
ENDIF()

#
# PROJECT INFO
#
PROJECT(hydrogen)
SET(VERSION_MAJOR "0")
SET(VERSION_MINOR "9")
SET(VERSION_PATCH "7")
#SET(VERSION_SUFFIX "rc1")

SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

SET(DISPLAY_VERSION "${VERSION}")

#IF(VERSION_SUFFIX)
#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
#ELSE() 
#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
#ENDIF(VERSION_SUFFIX)

SET(LIBSNDFILE_VERSION_PREV "1.0.17")

#
# CONFIG OPTIONS
#
SET(WANT_LIBTAR TRUE)
OPTION(WANT_DEBUG           "Build with debug information" ON)

IF(APPLE)
    OPTION(WANT_SHARED      "Build the core library shared." OFF)
ELSE()
    OPTION(WANT_SHARED      "Build the core library shared." ON)
ENDIF()

OPTION(WANT_LIBARCHIVE      "Enable use of libarchive instead of libtar" ON)
OPTION(WANT_LADSPA          "Enable use of LADSPA plugins" ON)

IF(APPLE)
	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" OFF)
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
ELSE()
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" ON)
ENDIF()

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" ON)
ELSE()
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
ENDIF()

OPTION(WANT_ALSA         "Include ALSA (Advanced Linux Sound Architecture) support" ON)
IF(MINGW)
	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" ON)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" ON)
ELSE()
	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
ENDIF()
OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
OPTION(WANT_RUBBERBAND   "Include RubberBand (Audio Time Stretcher Library) support" OFF)
IF(APPLE)
    OPTION(WANT_COREAUDIO   "Include CoreAudio support" ON)
    OPTION(WANT_COREMIDI    "Include CoreMidi support" ON)
    OPTION(WANT_BUNDLE      "Build a MAC OSX bundle application" ON)
ENDIF()

OPTION(WANT_CPPUNIT         "Include CppUnit test suite" ON)

IF(WANT_DEBUG)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(H2CORE_HAVE_DEBUG TRUE)
ELSE()
    SET(CMAKE_BUILD_TYPE Release)
    SET(H2CORE_HAVE_DEBUG FALSE)
ENDIF()

IF(WANT_BUNDLE)
    SET(H2CORE_HAVE_BUNDLE TRUE)
ELSE()
    SET(H2CORE_HAVE_BUNDLE FALSE)
ENDIF()

IF(WANT_SHARED)
    SET(H2CORE_LIBRARY_TYPE SHARED)
ELSE()
    SET(H2CORE_LIBRARY_TYPE STATIC)
ENDIF()

#SET(CMAKE_CXX_FLAGS "-fno-implement-inlines -finline-small-functions -findirect-inlining -fpartial-inlining")
SET(CMAKE_CXX_FLAGS "-O2 -std=gnu++11 -Wno-deprecated-register")
IF (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-implement-inlines")
ENDIF()

SET(CMAKE_CXX_FLAGS_RELEASE "")

SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")


IF(APPLE)
	#Compile for 32bit and 64bit intel macs
	SET (CMAKE_OSX_ARCHITECTURES "x86_64;")
ENDIF()
#
# MANDATORY PKGS AND DEFAULT OPTIONS
#
INCLUDE(StatusSupportOptions)
MANDATORY_PKG(QT4)
MANDATORY_PKG(Threads)
MANDATORY_PKG(LIBSNDFILE)

IF(MINGW)
    SET(WANT_JACK TRUE)
    SET(Threads_PATH "C:/Program Files/GnuWin32")
    SET(LIBARCHIVE_PATH "C:/Program Files/GnuWin32")
    SET(LIBSNDFILE_PATH "C:/Program Files/Mega-Nerd/libsndfile")
ELSE(MINGW)
    IF(APPLE)
		INCLUDE_DIRECTORIES("/opt/local/include")
        LINK_DIRECTORIES("/opt/local/lib")

		#Without setting this, installation would go into /usr/local, which does not exist per default
		SET(CMAKE_INSTALL_PREFIX "/usr" )
    ELSE(APPLE)
        SET(OSS_LIB_PATHS "/usr/lib${LIB_SUFFIX}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
        SET(RUBBERBAND_INCLUDE_PATHS "/usr/include/rubberband" )
    ENDIF(APPLE)
ENDIF(MINGW)

#Installation paths 
# TODO remove data from path
SET(SYS_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/hydrogen/data")
# TODO remove data from path, could be .config/hydrogen
SET(USR_DATA_PATH ".hydrogen/data")


SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
SET(MAX_COMPONENTS  32   CACHE STRING "Maximum number of components")
SET(MAX_NOTES       192  CACHE STRING "Maximum number of notes")
SET(MAX_LAYERS      16   CACHE STRING "Maximum number of layers")
SET(MAX_FX          4    CACHE STRING "Maximum number of effects")
SET(MAX_BUFFER_SIZE 8192 CACHE STRING "Maximum size of buffer")

#
# HEADER LIBRARY FUNCTIONS
#
INCLUDE(CompileHelper)
INCLUDE(FindHelper)
INCLUDE(FindLadspa)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindZLIB)
INCLUDE(FindThreads)
COMPILE_HELPER(SSCANF ${CMAKE_SOURCE_DIR}/cmake/sscanf sscanf )
COMPILE_HELPER(RTCLOCK ${CMAKE_SOURCE_DIR}/cmake/rtclock rtclock )
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(libtar.h HAVE_LIBTAR_H)
CHECK_LIBRARY_EXISTS(tar tar_open "" HAVE_LIBTAR_OPEN)
CHECK_LIBRARY_EXISTS(tar tar_close "" HAVE_LIBTAR_CLOSE)
CHECK_LIBRARY_EXISTS(tar tar_extract_all "" HAVE_LIBTAR_EXTRACT_ALL)
IF(HAVE_LIBTAR_H AND HAVE_LIBTAR_OPEN AND HAVE_LIBTAR_CLOSE AND HAVE_LIBTAR_EXTRACT_ALL)
    SET(LIBTAR_OK TRUE)
ELSE()
    SET(LIBTAR_OK FALSE)
ENDIF()
FIND_HELPER(LIBTAR tar tar.h tar)
IF( NOT LIBTAR_FOUND OR NOT LIBTAR_OK OR NOT ZLIB_FOUND )
    SET(WANT_LIBTAR FALSE)
    MANDATORY_PKG(LIBARCHIVE)
ENDIF()
FIND_HELPER(LIBARCHIVE libarchive archive.h archive)
IF( WANT_LIBARCHIVE AND LIBARCHIVE_FOUND)
    SET(WANT_LIBTAR FALSE)
ENDIF()
FIND_HELPER(LIBSNDFILE sndfile sndfile.h sndfile)
FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
FIND_LADSPA(LADSPA ladspa.h noise)

FIND_HELPER(NSMSESSION liblo lo/lo.h lo)

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
ELSE()
	FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
ENDIF()

FIND_HELPER(JACK jack jack/jack.h jack)
CHECK_LIBRARY_EXISTS(jack jack_port_rename "" HAVE_JACK_PORT_RENAME)
FIND_HELPER(JACKSESSION jack jack/session.h jack)
IF(APPLE)
    FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
    FIND_LIBRARY(CORESERVICES_LIBRARY CoreServices)
    FIND_HELPER(COREAUDIO CoreAudio-2.0 coreaudio.h coreaudio)
    FIND_HELPER(COREMIDI CoreMidi coremidi.h coremidi)
ENDIF()
FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
FIND_HELPER(PULSEAUDIO pulseaudio pulse/pulseaudio.h pulse)
FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
FIND_HELPER(LRDF lrdf lrdf.h lrdf)
FIND_HELPER(RAPTOR raptor2 raptor.h raptor)

FIND_HELPER(RUBBERBAND rubberband RubberBandStretcher.h rubberband)
FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)

# CHECK FOR Qt4
SET(QT_USE_QTNETWORK true)
SET(QT_USE_QTXML true)
SET(QT_USE_QTGUI true)
SET(QT_USE_QTXMLPATTERNS true)
FIND_PACKAGE(Qt4 4.3.0 REQUIRED)

find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs
		COMMENT "Generating API documentation with Doxygen" VERBATIM
		)
endif(DOXYGEN_FOUND)

#
# COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
#
SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION NSMSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RAPTOR RUBBERBAND CPPUNIT )
FOREACH( _pkg ${STATUS_LIST})
    COMPUTE_PKGS_FLAGS(${_pkg})
ENDFOREACH()

# LIBSNDFILE CHECKS
STRING( COMPARE GREATER "${LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
IF(LIBSNDFILE_VERSION_OK)
    SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
ELSE()
    SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats")
ENDIF()

# RUBBERBAND information
SET(LIBRUBBERBAND_MSG "The use of librubberband2 is marked as experimental.
*				 Because the current implementation produce wrong timing!
*				 So long this bug isn't solved, please disable this option.
*				 If rubberband-cli is installed, the hydrogen rubberband-function
*				 will work properly as expected.")

#
# CONFIG PROCESS SUMMARY
#
SET(reset "${_escape}[0m")
SET(red "${_escape}[1;31m")
SET(purple "${_escape}[1;35m")
SET(cyan "${_escape}[1;36m")

COLOR_MESSAGE("${cyan}Installation Summary${reset}
--------------------
* Install Directory            : ${CMAKE_INSTALL_PREFIX}
* User data path               : ${USR_DATA_PATH}
* System data path             : ${SYS_DATA_PATH}
* core library build as        : ${H2CORE_LIBRARY_TYPE}
* debug capabilities           : ${H2CORE_HAVE_DEBUG}
* macosx bundle                : ${H2CORE_HAVE_BUNDLE}
* fat build                    : ${WANT_FAT_BUILD}\n"
)

COLOR_MESSAGE("${cyan}Main librarires${reset}
* ${purple}libQt${reset}                        : ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}
* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
*                                ${LIBSNDFILE_MSG}
* ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
* ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
* ${purple}ladspa${reset}                       : ${LADSPA_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Supported audio interfaces${reset}
--------------------------
* ${purple}ALSA${reset}                         : ${ALSA_STATUS}
* ${purple}OSS${reset}                          : ${OSS_STATUS}
* ${purple}JACK${reset}                         : ${JACK_STATUS}
* ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
* ${purple}NSM Session${reset}                  : ${NSMSESSION_STATUS}   
* ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
* ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
* ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}
* ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Usefull extensions${reset}
-----------------------------------------
* ${purple}LASH${reset}                         : ${LASH_STATUS}
* ${purple}LRDF${reset}                         : ${LRDF_STATUS}
* ${purple}RUBBERBAND${reset}                   : ${RUBBERBAND_STATUS}
*                                ${LIBRUBBERBAND_MSG}\n"
)

IF(WANT_DEBUG)
    COLOR_MESSAGE("${cyan}Miscellaneous capabilities${reset}
-----------------------------------------
* realtime clock               : ${HAVE_RTCLOCK}
* working sscanf               : ${HAVE_SSCANF}
* unit tests                   : ${CPPUNIT_STATUS}\n"
    )
ENDIF()

COLOR_MESSAGE("-----------------------------------------------------------------
${red}IMPORTANT:${reset}
  after installing missing packages, remove ${CMAKE_BINARY_DIR}/CMakeCache.txt before
  running cmake again!
-----------------------------------------------------------------\n"
)

find_path( HYDROGEN_INSTALLED NAMES hydrogen/config.h )
IF( HYDROGEN_INSTALLED )

=== src/core/CMakeLists.txt ===

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/include/hydrogen/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" @ONLY)

FILE(GLOB_RECURSE hydrogen_INCLUDES include/*.h)
FILE(GLOB_RECURSE hydrogen_SOURCES src/*.cpp src/*.cc src/*.c)
LIST(APPEND hydrogen_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h)

ADD_LIBRARY( hydrogen-core-${VERSION} ${H2CORE_LIBRARY_TYPE} ${hydrogen_SOURCES})
INCLUDE_DIRECTORIES( include
    ${CMAKE_SOURCE_DIR}/include                 # regular headers
    ${CMAKE_CURRENT_BINARY_DIR}/include         # generated config.h
    ${QT_INCLUDES}
    ${LIBTAR_INCLUDE_DIR}
    ${LIBARCHIVE_INCLUDE_DIR}
    ${LIBSNDFILE_INCLUDE_DIR}
    ${ALSA_INCLUDE_DIR}
    ${OSS_INCLUDE_DIR}
    ${JACK_INCLUDE_DIR}
    ${PORTAUDIO_INCLUDE_DIR}
    ${PORTMIDI_INCLUDE_DIR}
    ${COREAUDIO_INCLUDE_DIR}
    ${COREMIDI_INCLUDE_DIR}
    ${LASH_INCLUDE_DIR}
    ${LRDF_INCLUDE_DIR}
    ${RAPTOR_INCLUDE_DIR}
    ${NSMSESSION_INCLUDE_DIR}
    ${RUBBERBAND_INCLUDE_DIR}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTXML_LIBRARY}
    ${QT_QTXMLPATTERNS_LIBRARY}
    ${LIBTAR_LIBRARIES}
    ${LIBARCHIVE_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${OSS_LIBRARIES}
    ${JACK_LIBRARIES}
    ${PORTAUDIO_LIBRARIES}
    ${PORTMIDI_LIBRARIES}
    ${AUDIOUNIT_LIBRARY}
    ${CORESERVICES_LIBRARY}
    ${COREAUDIO_LIBRARIES}
    ${COREMIDI_LIBRARIES}
    ${PULSEAUDIO_LIBRARIES}
    ${LASH_LIBRARIES}
    ${LRDF_LIBRARIES}
    ${RUBBERBAND_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${NSMSESSION_LIBRARIES}
)

#SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )

INSTALL(TARGETS hydrogen-core-${VERSION}
    LIBRARY DESTINATION "lib${LIB_SUFFIX}"
    ARCHIVE DESTINATION "lib${LIB_SUFFIX}"
    # do not copy directory hierarchy
    #PUBLIC_HEADER DESTINATION include/hydrogen
)

IF(NOT APPPLE AND NOT WIN32)
    INSTALL(DIRECTORY include DESTINATION "${CMAKE_INSTALL_PREFIX}" FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
    INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" DESTINATION "${CMAKE_INSTALL_PREFIX}/include/hydrogen" )
ENDIF()

=== src/tests/CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
add_definitions()
include_directories(
    ${CMAKE_SOURCE_DIR}/src/core/include            # core headers
    ${CMAKE_BINARY_DIR}/src/core/include            # generated config.h
    ${QT_INCLUDES}                                  # TODO be able to remove this
	${CPPUNIT_INCLUDE_DIR}
)
FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
link_directories()
add_executable(tests ${TESTS_SRCS})
target_link_libraries(tests
    hydrogen-core-${VERSION}
	${CPPUNIT_LIBRARIES}
)
add_dependencies(tests hydrogen-core-${VERSION})

=== debian/changelog ===
hydrogen (0.9.7-6) unstable; urgency=medium

  * Extend patch 2001 to contain no builtin default feed URL.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2017 21:56:43 +0200

hydrogen (0.9.7-5) unstable; urgency=medium

  * Fix install all architecture-independent data in hydrogen-data.
    Bump breaks+replaces.
  * Fix install appdata below /usr/share/metainfo.
  * Limit patch 2001 to patch config file (not builtin defaults.
    Thanks to IOhannes m zmölnig.
  * Tighten lintian overrides regarding License-Reference.
  * Declare compliance with Debian Policy 4.1.0.
  * Add lintian override for separation of command from desktop file.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2017 20:10:16 +0200

hydrogen (0.9.7-4) unstable; urgency=medium

  * Fix missing DEP-3 headers for patch 1000 (seems from git commits
    that I wrote that patch, although I don't remember it).
  * Add README.Debian documenting deviation from upstream regarding
    online downloadable drumkit feeds.
    Thanks to IOhannes m zmölnig.
  * Tidy rules file: Reorganize package relations variables.
  * Add patch cherry-picked upstream to fix crash enabling rubberband
    with new empty instrument component.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 18 Sep 2017 23:14:30 +0200

hydrogen (0.9.7-3) unstable; urgency=medium

  * Add patch 2001 to offer live download of only free drumkits by
    default.
  * Modernize Vcs-* fields: Use git (not cgit) in path.
  * Declare compliance with Debian Policy 4.0.1.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Aug 2017 21:04:32 +0200

hydrogen (0.9.7-2) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * Remove unused B-D on libaudiofile-dev.

  [ Jonas Smedegaard ]
  * Fix drop README.source section about special care for CDBS: Directly
    contradicts section emphasizing that *no* special care is needed
    (CDBS users handle merges).
  * Revert to debhelper compatibility level 9: No concrete need, and may
    complicate backortability.
  * Update patches:
    + Refresh with shortening quilt options.
  * Update copyright info:
    + List Github as source.
    + List Github issue tracker as preferred upstream contact.
    + Use https protocol in initial format line.
    + Fix double-space delimit copyright holders.
    + Merge equally licensed Files sections.
    + Fix reduce coverage for Jonathan Dempsey.
    + Fix list all authors of ladspa headers.
    + Fix cover wasp plugin, cmake scripts, and another author of main
      upstream source.
    + Fix cover a file where license is guessed.
    + Use License-Grant and License-Reference fields.
      Thanks to Ben Finney.
    + Extend coverage of packaging.
    + Relicense packaging as GPL-3+.
  * Update watch file:
    + Bump to version 4.
    + Mention gpb in usage comment.
    + Add filenamemangle.
    + Tighten uversionmangle.
    + Tighten version match.
  * Update package relations:
    + Relax to build-depend unversioned on libsndfile1-dev: Needed
      version satisfied even in oldstable.
  * Improve copyright-check:
    + Move to manually invoked script in source (not run during build).
      Stop build-depend on licensecheck.
    + Extract metadata from spreadsheets (not only images).
    + Skip images and audio without metadata.
    + Skip more types of compiled localizations.
  * Drop TODO about manpage generation peculiarity: Upstream shipped
    manpage used since 0.9.7-1.
  * Add lintian overrides regarding license in License-Reference field.
    See bug#786450.
  * Modernize cdbs:
    + Drop build target get-orig-source: Use gbp import-orig --uscan.
  * Install only compiled machine-readable locale files (not XML nor
    maintenance tools).
    Drop (wrong) lintian suppression about installed maintenance tools.
  * Suggest ladspa-plugin.
  * (Re)generate locale files from code sources during build.
  * Advertise DEP3 format in patch headers.
  * Add patch 1002 to include ca locale when regenerating translations.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 21 Jul 2017 08:38:57 +0200

hydrogen (0.9.7-1) unstable; urgency=medium

  * New upstream version 0.9.7
  * Split package.
    * hydrogen - binary
    * hydrogen-data * architecture-independent data files
                    * demo_songs, drumkits, translations
    * hydrogen-doc  * documentation
  * debian/patches
    * Patches refreshed.
    * Renumbering patches.
    * Add patch to fix install path for upstream man pages.
    * 1008-desktop.patch not needed anymore.
    * portaudio patch refreshed/enabled.
    * Add patch fixing CXX FLAGS.
    * Add spelling patch.
    * Patches forwarded.
  * debian/control
    * Bump Standards.
    * Fix VCS fields.
    * Add me as uploader also to control.in file.
  * debian/copyright
    * Update copyright_hints.
    * Update copyright file.
  * debian/rules
    * Fix hardening.
    * Set dh/compat 10.
  * Remove menu file.
  * Improve README.source file.
  * Set section doc for doc package.
  * Add link to SVG icon. (Closes: #795474)
  * Build docs. (Closes: #629107)
    * Thanks to James Cowgill!
  * Set libportmidi-dev linux-any to build on non-linux archs (Closes: #591301).
  * Add hydrogen-data.lintian-overrides file.
  * Don't create xmp icon.
  * Not install xpm icon any more.
  * Remove B-D for image conversion - not needed any more.
  * Don't sign tags.
  * Handle upstream git files by d/gbp.conf rather then d/copyright.
  * Install upstream man pages and hydrogen.appdata.xml.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 29 Nov 2016 22:01:10 +0000

=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 cdbs,
 debhelper,
 dh-buildinfo,
 cmake,
 libqt4-dev,
 libz-dev,
 pkg-config,
 libarchive-dev,
 docbook-utils,
 poxml,
 xmlto,
 libxml2-utils,
 libasound2-dev [linux-any],
 libjack-dev,
 liblrdf-dev,
 libsndfile1-dev,
 portaudio19-dev,
 libportmidi-dev [linux-any],
 libpulse-dev
Standards-Version: 4.1.0
Homepage: http://www.hydrogen-music.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git

Package: hydrogen
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 hydrogen-data (= ${source:Version})
Recommends:
 hydrogen-drumkits,
 hydrogen-doc,
 rubberband-cli
Suggests:
 ladspa-plugin
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on QT 4.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio and OSS audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 0.9.7-5~)
Replaces: hydrogen (<< 0.9.7-5~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 This package contains the architecture-independent data files.

Package: hydrogen-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: hydrogen (<< 0.9.7-1~)
Replaces: hydrogen (<< 0.9.7-1~)
Description: advanced drum machine/step sequencer (doc)
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 This package contains the architecture-independent documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2010-2011, 2017 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for Hydrogen
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

# suppress checking license during build
DEB_COPYRIGHT_CHECK_LICENSECHECK =
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Needed by upstream build
bdeps = cmake, libqt4-dev, libz-dev, pkg-config, libarchive-dev
bdeps +=, docbook-utils, poxml, xmlto, libxml2-utils
bdeps +=, libasound2-dev [linux-any], libjack-dev, liblrdf-dev
bdeps +=, libsndfile1-dev, portaudio19-dev, libportmidi-dev [linux-any]
bdeps +=, libpulse-dev

CDBS_BUILD_DEPENDS +=, $(bdeps)

DEB_CMAKE_EXTRA_FLAGS = -DWANT_SHARED=OFF \
 -DWANT_PORTAUDIO=ON \
 -DWANT_PORTMIDI=ON \
 -DWANT_RUBBERBAND=ON

# according to upstream INSTALL.txt this avoids potential clash with Qt3
export QTDIR=/usr/share/qt4

common-build-indep:: debian/docs.stamp
debian/docs.stamp:
	$(MAKE) -C data/doc
	touch $@
clean::
	rm -f debian/docs.stamp
	rm -rf CMakeCache.txt CMakeFiles/ try/
	rm -f qt4.pyc version.cpp config.h

# (Re)generate locale files from code sources
DEB_UPSTREAM_CRUFT_MOVE = usr/share/hydrogen/data/i18n/*.qm
build/hydrogen-data:: debian/l10n.stamp
debian/l10n.stamp:
	cd data/i18n && ./updateTranslations.sh
	touch $@
clean::
	rm -f debian/l10n.stamp

binary-install/hydrogen::
	find $(CURDIR)/debian/hydrogen/usr/share/ -type d -empty -delete
	rm -rf $(CURDIR)/debian/hydrogen/usr/lib/
	rm -rf $(CURDIR)/debian/hydrogen/usr/include/

## hydrogen 1.0.0~beta1

=== debian/changelog ===
hydrogen (1.0.0~beta1-0ubuntu1) focal; urgency=medium

  * New upstream version 1.0.0-beta1 (required for Qt4 removal)
  * Bump standards, compat to 10 for CDBS compatibility
  * Add self to debian/copyright
  * Update build for python
  * Patch to remove beta nag

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 06 Nov 2019 07:36:33 -0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Erich Eickmeyer <erich@ericheickmeyer.com>
 Uploaders:
+ Erich Eickmeyer <erich@ericheickmeyer.com>,
  Jonas Smedegaard <dr@jones.dk>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
@@ -10,25 +12,30 @@
  debhelper,
  dh-buildinfo,
  cmake,
- libqt4-dev,
+ qtbase5-dev,
  libz-dev,
  pkg-config,
  libarchive-dev,
  docbook-utils,
  poxml,
  xmlto,
+ ladspa-sdk,
+ libqt5xmlpatterns5-dev,
  libxml2-utils,
  libasound2-dev [linux-any],
- libjack-dev,
+ libjack-jackd2-dev,
  liblrdf-dev,
+ liblo-dev,
  libsndfile1-dev,
+ libtar-dev,
  portaudio19-dev,
+ qttools5-dev-tools,
  libportmidi-dev [linux-any],
  libpulse-dev
-Standards-Version: 4.1.0
+Standards-Version: 4.3.0
 Homepage: http://www.hydrogen-music.org/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen
 
 Package: hydrogen
 Architecture: any
@@ -48,7 +55,7 @@
  .
  General features:
   * Very user-friendly, modular, fast and intuitive graphical interface
-    based on QT 4.
+    based on QT 5.
   * Sample-based stereo audio engine, with import of sound samples in
     .wav, .au and .aiff formats.
   * Support of samples in compressed FLAC file.
@@ -66,7 +73,7 @@
   * Multiple patterns playing at once.
  .
  Other features:
-  * JACK, ALSA, PortAudio and OSS audio drivers.
+  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
   * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
     ALL).
   * Import/export of drumkits.
@@ -78,8 +85,8 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: hydrogen
-Breaks: hydrogen (<< 0.9.7-5~)
-Replaces: hydrogen (<< 0.9.7-5~)
+Breaks: hydrogen (<< 1.0.0~)
+Replaces: hydrogen (<< 1.0.0-0~)
 Description: advanced drum machine/step sequencer (data)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.
@@ -91,8 +98,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Breaks: hydrogen (<< 0.9.7-1~)
-Replaces: hydrogen (<< 0.9.7-1~)
+Breaks: hydrogen (<< 1.0.0~)
+Replaces: hydrogen (<< 1.0.0~)
 Description: advanced drum machine/step sequencer (doc)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.

## hydrogen 1.0.0~beta2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # CMAKE SETUP
 #
 
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
 SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 # The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
 # http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
@@ -16,21 +16,21 @@
 # PROJECT INFO
 #
 PROJECT(hydrogen)
-SET(VERSION_MAJOR "0")
-SET(VERSION_MINOR "9")
-SET(VERSION_PATCH "7")
-#SET(VERSION_SUFFIX "rc1")
+SET(VERSION_MAJOR "1")
+SET(VERSION_MINOR "0")
+SET(VERSION_PATCH "0")
+SET(VERSION_SUFFIX "beta2")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
-SET(DISPLAY_VERSION "${VERSION}")
-
-#IF(VERSION_SUFFIX)
-#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
-#ELSE() 
-#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
-#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
-#ENDIF(VERSION_SUFFIX)
+IF(VERSION_SUFFIX)
+	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+ELSE()
+	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
+ENDIF(VERSION_SUFFIX)
+
+include(GNUInstallDirs)
 
 SET(LIBSNDFILE_VERSION_PREV "1.0.17")
 
@@ -39,22 +39,23 @@
 #
 SET(WANT_LIBTAR TRUE)
 OPTION(WANT_DEBUG           "Build with debug information" ON)
-
 IF(APPLE)
     OPTION(WANT_SHARED      "Build the core library shared." OFF)
+    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" OFF)
 ELSE()
     OPTION(WANT_SHARED      "Build the core library shared." ON)
+    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" ON)
 ENDIF()
 
 OPTION(WANT_LIBARCHIVE      "Enable use of libarchive instead of libtar" ON)
 OPTION(WANT_LADSPA          "Enable use of LADSPA plugins" ON)
 
 IF(APPLE)
-	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" OFF)
+	OPTION(WANT_OSC  "Enable OSC support" OFF)
 	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
 ELSE()
 	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
-	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" ON)
+	OPTION(WANT_OSC  "Enable OSC support" ON)
 ENDIF()
 
 IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
@@ -63,16 +64,14 @@
 	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
 ENDIF()
 
-OPTION(WANT_ALSA         "Include ALSA (Advanced Linux Sound Architecture) support" ON)
 IF(MINGW)
-	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 	OPTION(WANT_PORTAUDIO    "Include PortAudio support" ON)
 	OPTION(WANT_PORTMIDI     "Include PortMidi support" ON)
 ELSE()
-	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 	OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
 	OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
 ENDIF()
+OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
 OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
 OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
@@ -105,8 +104,12 @@
     SET(H2CORE_LIBRARY_TYPE STATIC)
 ENDIF()
 
-#SET(CMAKE_CXX_FLAGS "-fno-implement-inlines -finline-small-functions -findirect-inlining -fpartial-inlining")
-SET(CMAKE_CXX_FLAGS "-O2 -std=gnu++11 -Wno-deprecated-register")
+IF(WANT_DEBUG)
+	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
+ELSE()
+	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
+ENDIF()
+
 IF (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-implement-inlines")
 ENDIF()
@@ -124,39 +127,37 @@
 # MANDATORY PKGS AND DEFAULT OPTIONS
 #
 INCLUDE(StatusSupportOptions)
-MANDATORY_PKG(QT4)
 MANDATORY_PKG(Threads)
 MANDATORY_PKG(LIBSNDFILE)
 
-IF(MINGW)
-    SET(WANT_JACK TRUE)
-    SET(Threads_PATH "C:/Program Files/GnuWin32")
-    SET(LIBARCHIVE_PATH "C:/Program Files/GnuWin32")
-    SET(LIBSNDFILE_PATH "C:/Program Files/Mega-Nerd/libsndfile")
-ELSE(MINGW)
-    IF(APPLE)
-		INCLUDE_DIRECTORIES("/opt/local/include")
-        LINK_DIRECTORIES("/opt/local/lib")
-
-		#Without setting this, installation would go into /usr/local, which does not exist per default
-		SET(CMAKE_INSTALL_PREFIX "/usr" )
-    ELSE(APPLE)
-        SET(OSS_LIB_PATHS "/usr/lib${LIB_SUFFIX}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
-        SET(RUBBERBAND_INCLUDE_PATHS "/usr/include/rubberband" )
-    ENDIF(APPLE)
-ENDIF(MINGW)
-
-#Installation paths 
+# http://doc.qt.io/qt-5/cmake-manual.html
+FIND_PACKAGE(Qt5Widgets REQUIRED)
+FIND_PACKAGE(Qt5Xml REQUIRED)
+FIND_PACKAGE(Qt5XmlPatterns REQUIRED)
+FIND_PACKAGE(Qt5LinguistTools REQUIRED)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTOUIC ON)
+
+IF(APPLE)
+    INCLUDE_DIRECTORIES("/opt/local/include")
+    LINK_DIRECTORIES("/opt/local/lib")
+
+    #Without setting this, installation would go into /usr/local, which does not exist per default
+    SET(CMAKE_INSTALL_PREFIX "/usr" )
+ELSE(APPLE)
+    SET(OSS_LIB_PATHS "${CMAKE_INSTALL_FULL_LIBDIR}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
+ENDIF(APPLE)
+
+
+#Installation paths
 # TODO remove data from path
-SET(SYS_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/hydrogen/data")
+SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
 # TODO remove data from path, could be .config/hydrogen
-SET(USR_DATA_PATH ".hydrogen/data")
-
+SET(H2_USR_PATH ".hydrogen")
 
 SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
 SET(MAX_COMPONENTS  32   CACHE STRING "Maximum number of components")
 SET(MAX_NOTES       192  CACHE STRING "Maximum number of notes")
-SET(MAX_LAYERS      16   CACHE STRING "Maximum number of layers")
 SET(MAX_FX          4    CACHE STRING "Maximum number of effects")
 SET(MAX_BUFFER_SIZE 8192 CACHE STRING "Maximum size of buffer")
 
@@ -196,7 +197,7 @@
 FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
 FIND_LADSPA(LADSPA ladspa.h noise)
 
-FIND_HELPER(NSMSESSION liblo lo/lo.h lo)
+FIND_HELPER(OSC liblo lo/lo.h lo)
 
 IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
 	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
@@ -215,35 +216,37 @@
 ENDIF()
 FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
 FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
-FIND_HELPER(PULSEAUDIO pulseaudio pulse/pulseaudio.h pulse)
+FIND_HELPER(PULSEAUDIO libpulse pulse/pulseaudio.h pulse)
 FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
 FIND_HELPER(LRDF lrdf lrdf.h lrdf)
-FIND_HELPER(RAPTOR raptor2 raptor.h raptor)
-
-FIND_HELPER(RUBBERBAND rubberband RubberBandStretcher.h rubberband)
+
+FIND_HELPER(RUBBERBAND rubberband rubberband/RubberBandStretcher.h rubberband)
 FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)
 
-# CHECK FOR Qt4
-SET(QT_USE_QTNETWORK true)
-SET(QT_USE_QTXML true)
-SET(QT_USE_QTGUI true)
-SET(QT_USE_QTXMLPATTERNS true)
-FIND_PACKAGE(Qt4 4.3.0 REQUIRED)
+
+# Find includes in corresponding build directories
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+# Instruct CMake to run moc automatically when needed.
+#set(CMAKE_AUTOMOC ON)
+
 
 find_package(Doxygen)
 if(DOXYGEN_FOUND)
 	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+	add_custom_target(doc_dir ALL COMMAND ${CMAKE_COMMAND}
+		-E make_directory ${CMAKE_CURRENT_BINARY_DIR}/docs)
 	add_custom_target(doc
 		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
-                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs
-		COMMENT "Generating API documentation with Doxygen" VERBATIM
-		)
+		DEPENDS doc_dir
+		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
+		COMMENT "Generating API documentation with Doxygen"
+		VERBATIM)
 endif(DOXYGEN_FOUND)
 
 #
 # COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
 #
-SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION NSMSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RAPTOR RUBBERBAND CPPUNIT )
+SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
 FOREACH( _pkg ${STATUS_LIST})
     COMPUTE_PKGS_FLAGS(${_pkg})
 ENDFOREACH()
@@ -274,17 +277,17 @@
 COLOR_MESSAGE("${cyan}Installation Summary${reset}
 --------------------
 * Install Directory            : ${CMAKE_INSTALL_PREFIX}
-* User data path               : ${USR_DATA_PATH}
-* System data path             : ${SYS_DATA_PATH}
+* User path                    : ${H2_USR_PATH}
+* System path                  : ${H2_SYS_PATH}
 * core library build as        : ${H2CORE_LIBRARY_TYPE}
 * debug capabilities           : ${H2CORE_HAVE_DEBUG}
 * macosx bundle                : ${H2CORE_HAVE_BUNDLE}
 * fat build                    : ${WANT_FAT_BUILD}\n"
 )
 
-COLOR_MESSAGE("${cyan}Main librarires${reset}
-* ${purple}libQt${reset}                        : ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}
-* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
+COLOR_MESSAGE("${cyan}Main librarires${reset}")
+COLOR_MESSAGE("* ${purple}libQt${reset}                        : ${Qt5Widgets_VERSION}")
+COLOR_MESSAGE("* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
 *                                ${LIBSNDFILE_MSG}
 * ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
 * ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
@@ -297,7 +300,7 @@
 * ${purple}OSS${reset}                          : ${OSS_STATUS}
 * ${purple}JACK${reset}                         : ${JACK_STATUS}
 * ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
-* ${purple}NSM Session${reset}                  : ${NSMSESSION_STATUS}   
+* ${purple}OSC${reset}                          : ${OSC_STATUS}
 * ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
 * ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
 * ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
@@ -305,7 +308,7 @@
 * ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
 )
 
-COLOR_MESSAGE("${cyan}Usefull extensions${reset}
+COLOR_MESSAGE("${cyan}Useful extensions${reset}
 -----------------------------------------
 * ${purple}LASH${reset}                         : ${LASH_STATUS}
 * ${purple}LRDF${reset}                         : ${LRDF_STATUS}
@@ -331,3 +334,6 @@
 
 find_path( HYDROGEN_INSTALLED NAMES hydrogen/config.h )
 IF( HYDROGEN_INSTALLED )
+    COLOR_MESSAGE("-----------------------------------------------------------------
+${red}IMPORTANT${reset}:
+  previously installed hydrogen headers found in ${HYDROGEN_INSTALLED}

=== src/gui/CMakeLists.txt ===

FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp)

# add undiscovered dependencies to generated config.h
INCLUDE(AddFileDependencies)
FOREACH( _file ${hydrogen_H} ${hydrogen_SRCS})
    FILE(READ "${_file}" _FILE_CONTENT)
    IF( "${_FILE_CONTENT}" MATCHES "H2CORE_HAVE_" )
        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/include/hydrogen/config.h)
    ENDIF()
ENDFOREACH()

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_BINARY_DIR}                 # ui_ headers
    ${CMAKE_CURRENT_SOURCE_DIR}/src             # gui headers
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
)

IF(APPLE)
	# set how it shows up in the Info.plist file
     	SET(MACOSX_BUNDLE_INFO_STRING "Hydrogen for Mac")
	SET(MACOSX_BUNDLE_ICON_FILE "icon.icns")
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "Hydrogen")
	SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${VERSION}")
	#this has to be short since it appears as the application name in the menu bar
	SET(MACOSX_BUNDLE_BUNDLE_NAME "Hydrogen")
	SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VERSION}")
	SET(MACOSX_BUNDLE_BUNDLE_VERSION "${VERSION}")
	SET(MACOSX_BUNDLE_COPYRIGHT "Hydrogen Developers, 2009")

  	# set where in the bundle to put the icns file
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	# include the icns file in the target
	SET(hydrogen_SRCS ${hydrogen_SRCS} ${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns)
	
	#copy the data folder
	FILE(COPY ${CMAKE_SOURCE_DIR}/data DESTINATION hydrogen.app/Contents/Resources PATTERN ".svn" EXCLUDE)
  	
ENDIF()

ADD_EXECUTABLE(hydrogen WIN32 MACOSX_BUNDLE ${hydrogen_SRCS} ${hydrogen_MOC} ${hydrogen_UIS_H} ${CMAKE_SOURCE_DIR}/windows/icon.rc)
SET_PROPERTY(TARGET hydrogen PROPERTY CXX_STANDARD 14)

TARGET_LINK_LIBRARIES(hydrogen
	hydrogen-core-${VERSION}
	Qt5::Widgets
)
ADD_DEPENDENCIES(hydrogen hydrogen-core-${VERSION})

INSTALL(TARGETS hydrogen RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -10,9 +10,14 @@
 FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
 link_directories()
 add_executable(tests ${TESTS_SRCS})
+
+SET_PROPERTY(TARGET tests PROPERTY CXX_STANDARD 14)
+
 target_link_libraries(tests
-    hydrogen-core-${VERSION}
+	hydrogen-core-${VERSION}
 	${CPPUNIT_LIBRARIES}
+	Qt5::Core
 )
+
 add_dependencies(tests hydrogen-core-${VERSION})

=== debian/changelog ===
hydrogen (1.0.0~beta2-0ubuntu1) focal; urgency=medium

  * New upstream version 1.0.0-beta2

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 25 Mar 2020 11:40:01 -0700

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  Jonas Smedegaard <dr@jones.dk>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- cdbs,
+  cdbs,
  debhelper,
  dh-buildinfo,
  cmake,
@@ -29,7 +29,9 @@
  libsndfile1-dev,
  libtar-dev,
  portaudio19-dev,
+ python2,
  qttools5-dev-tools,
+ qttools5-dev,
  libportmidi-dev [linux-any],
  libpulse-dev
 Standards-Version: 4.3.0
@@ -86,7 +88,7 @@
 Depends: ${misc:Depends}
 Recommends: hydrogen
 Breaks: hydrogen (<< 1.0.0~)
-Replaces: hydrogen (<< 1.0.0-0~)
+Replaces: hydrogen (<< 1.0.0~)
 Description: advanced drum machine/step sequencer (data)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.

=== debian/rules ===
--- 
+++ 
@@ -27,9 +27,9 @@
 CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
 
 # Needed by upstream build
-bdeps = cmake, libqt4-dev, libz-dev, pkg-config, libarchive-dev
+bdeps = cmake, qtbase5-dev, libz-dev, pkg-config, libarchive-dev
 bdeps +=, docbook-utils, poxml, xmlto, libxml2-utils
-bdeps +=, libasound2-dev [linux-any], libjack-dev, liblrdf-dev
+bdeps +=, libasound2-dev [linux-any], libjack-jackd2-dev, liblrdf-dev
 bdeps +=, libsndfile1-dev, portaudio19-dev, libportmidi-dev [linux-any]
 bdeps +=, libpulse-dev
 
@@ -41,16 +41,7 @@
  -DWANT_RUBBERBAND=ON
 
 # according to upstream INSTALL.txt this avoids potential clash with Qt3
-export QTDIR=/usr/share/qt4
-
-common-build-indep:: debian/docs.stamp
-debian/docs.stamp:
-	$(MAKE) -C data/doc
-	touch $@
-clean::
-	rm -f debian/docs.stamp
-	rm -rf CMakeCache.txt CMakeFiles/ try/
-	rm -f qt4.pyc version.cpp config.h
+export QTDIR=/usr/lib/qt5
 
 # (Re)generate locale files from code sources
 DEB_UPSTREAM_CRUFT_MOVE = usr/share/hydrogen/data/i18n/*.qm

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,uversionmangle=s/(\d)-(alpha|beta|rc)/$1~$2/"
 https://github.com/hydrogen-music/hydrogen/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian
